#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

#ifndef FALSE
#define FALSE 0
#endif
#ifndef TRUE
#define TRUE 1
#endif
typedef struct scrap_node {
  struct scrap_node *next;
  int scrap;
} Scrap_Node;
typedef struct name {
  char *spelling;
  struct name *llink;
  struct name *rlink;
  Scrap_Node *defs;
  Scrap_Node *uses;
  int mark;
  char tab_flag;
  char indent_flag;
  char debug_flag;
} Name;


#define TEX(s) if (tex_flag) fputs(s,tex_file)
#define LATEX(s) if (latex_flag) fputs(s,tex_file)


extern int doc_flag;      
extern int tex_flag;      
extern int latex_flag;    
extern int html_flag;     
extern int output_flag;   
extern int compare_flag;  
extern int verbose_flag;  
extern int write_flag;    
extern int number_flag;   
extern int make_flag;     
extern int cross_flag;    
extern char *command_name;
extern char *make_name;
extern char *source_name;  /* name of the current file */
extern int source_line;    /* current line in the source file */
extern int source_peek;    /* next character in source file */
extern int already_warned;
extern Name *file_names;
extern Name *macro_names;
extern Name *user_names;

extern void pass1();
extern void write_latex();
extern void write_tex();
extern Scrap_Node *get_defs();
extern void write_html();
extern void write_files();
extern void source_open(); /* pass in the name of the source file */
extern int source_get();   /* no args; returns the next char or EOF */
extern void init_scraps();
extern int collect_scrap();
extern int write_scraps();
extern void write_scrap_ref();
extern void write_single_scrap_ref();
extern void collect_numbers();
extern Name *collect_file_name();
extern Name *collect_macro_name();
extern Name *collect_scrap_name();
extern Name *name_add();
extern Name *prefix_add();
extern char *save_string();
extern void reverse_lists();
extern void search();
extern void *arena_getmem();
extern void arena_free();

